diff --git a/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileServlet.java b/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileServlet.java
index 368e36590b0866d8628d54293b951122f6e28665..7bc6304be85fcc794ba2bf56c819b4d49990b1e9 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileServlet.java
@@ -215,9 +215,9 @@ public class ProfileServlet extends CMSServlet {
             } else if (v instanceof ArgSet) {
                 ArgSet set = (ArgSet) v;
                 ps.println("<set>");
-                Enumeration names = set.getNames();
+                Enumeration<String> names = set.getNames();
                 while (names.hasMoreElements()) {
-                    String n = (String) names.nextElement();
+                    String n = names.nextElement();
                     outputArgValueAsXML(ps, n, set.get(n));
                 }
                 ps.println("</set>");
@@ -426,10 +426,10 @@ public class ProfileServlet extends CMSServlet {
 
     protected void outputArgSet(PrintWriter writer, String name, ArgSet set)
             throws IOException {
-        Enumeration e = set.getNames();
+        Enumeration<String> e = set.getNames();
 
         while (e.hasMoreElements()) {
-            String n = (String) e.nextElement();
+            String n = e.nextElement();
             IArgValue val = set.get(n);
 
             if (val instanceof ArgSet) {
@@ -452,10 +452,10 @@ public class ProfileServlet extends CMSServlet {
             throws IOException {
         if (set == null)
             return;
-        Enumeration e = set.getNames();
+        Enumeration<String> e = set.getNames();
 
         while (e.hasMoreElements()) {
-            String n = (String) e.nextElement();
+            String n = e.nextElement();
             IArgValue val = set.get(n);
 
             if (val instanceof ArgSet) {
diff --git a/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileSubmitCMCServlet.java b/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileSubmitCMCServlet.java
index 04a2c55d50c1ef38b07fb9e1c490715b86dae4d6..d021ef3878ce3c786531f4a1b71bab2ea85a6001 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileSubmitCMCServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/profile/ProfileSubmitCMCServlet.java
@@ -120,16 +120,16 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
     private void setInputsIntoContext(HttpServletRequest request, IProfile profile, IProfileContext ctx) {
 
         // passing inputs into context
-        Enumeration inputIds = profile.getProfileInputIds();
+        Enumeration<String> inputIds = profile.getProfileInputIds();
 
         if (inputIds != null) {
             while (inputIds.hasMoreElements()) {
-                String inputId = (String) inputIds.nextElement();
+                String inputId = inputIds.nextElement();
                 IProfileInput profileInput = profile.getProfileInput(inputId);
-                Enumeration inputNames = profileInput.getValueNames();
+                Enumeration<String> inputNames = profileInput.getValueNames();
 
                 while (inputNames.hasMoreElements()) {
-                    String inputName = (String) inputNames.nextElement();
+                    String inputName = inputNames.nextElement();
 
                     if (request.getParameter(inputName) != null) {
                         ctx.set(inputName, request.getParameter(inputName));
@@ -142,11 +142,11 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
 
     private void setCredentialsIntoContext(HttpServletRequest request, IProfileAuthenticator authenticator,
             IProfileContext ctx) {
-        Enumeration authIds = authenticator.getValueNames();
+        Enumeration<String> authIds = authenticator.getValueNames();
 
         if (authIds != null) {
             while (authIds.hasMoreElements()) {
-                String authName = (String) authIds.nextElement();
+                String authName = authIds.nextElement();
 
                 if (request.getParameter(authName) != null) {
                     ctx.set(authName, request.getParameter(authName));
@@ -160,11 +160,11 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
         AuthCredentials credentials = new AuthCredentials();
 
         // build credential
-        Enumeration authNames = authenticator.getValueNames();
+        Enumeration<String> authNames = authenticator.getValueNames();
 
         if (authNames != null) {
             while (authNames.hasMoreElements()) {
-                String authName = (String) authNames.nextElement();
+                String authName = authNames.nextElement();
 
                 if (authName.equals("cert_request"))
                     credentials.set(authName, requestB64);
@@ -188,17 +188,17 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
 
     private void setInputsIntoRequest(HttpServletRequest request, IProfile
             profile, IRequest req) {
-        Enumeration inputIds = profile.getProfileInputIds();
+        Enumeration<String> inputIds = profile.getProfileInputIds();
 
         if (inputIds != null) {
             while (inputIds.hasMoreElements()) {
-                String inputId = (String) inputIds.nextElement();
+                String inputId = inputIds.nextElement();
                 IProfileInput profileInput = profile.getProfileInput(inputId);
-                Enumeration inputNames = profileInput.getValueNames();
+                Enumeration<String> inputNames = profileInput.getValueNames();
 
                 if (inputNames != null) {
                     while (inputNames.hasMoreElements()) {
-                        String inputName = (String) inputNames.nextElement();
+                        String inputName = inputNames.nextElement();
 
                         if (request.getParameter(inputName) != null) {
                             req.setExtData(inputName, request.getParameter(inputName));
@@ -262,10 +262,11 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
 
         if (CMS.debugOn()) {
             CMS.debug("Start of ProfileSubmitCMCServlet Input Parameters");
-            Enumeration paramNames = request.getParameterNames();
+            @SuppressWarnings("unchecked")
+            Enumeration<String> paramNames = request.getParameterNames();
 
             while (paramNames.hasMoreElements()) {
-                String paramName = (String) paramNames.nextElement();
+                String paramName = paramNames.nextElement();
                 // added this facility so that password can be hidden,
                 // all sensitive parameters should be prefixed with 
                 // __ (double underscores); however, in the event that
@@ -552,9 +553,9 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
 
             // serial auth token into request
             if (authToken != null) {
-                Enumeration tokenNames = authToken.getElements();
+                Enumeration<String> tokenNames = authToken.getElements();
                 while (tokenNames.hasMoreElements()) {
-                    String tokenName = (String) tokenNames.nextElement();
+                    String tokenName = tokenNames.nextElement();
                     String[] vals = authToken.getInStringArray(tokenName);
                     if (vals != null) {
                         for (int i = 0; i < vals.length; i++) {
@@ -659,9 +660,9 @@ public class ProfileSubmitCMCServlet extends ProfileServlet {
 
                     // print request debug
                     if (reqs[k] != null) {
-                        Enumeration reqKeys = reqs[k].getExtDataKeys();
+                        Enumeration<String> reqKeys = reqs[k].getExtDataKeys();
                         while (reqKeys.hasMoreElements()) {
-                            String reqKey = (String) reqKeys.nextElement();
+                            String reqKey = reqKeys.nextElement();
                             String reqVal = reqs[k].getExtDataInString(reqKey);
                             if (reqVal != null) {
                                 CMS.debug("ProfileSubmitCMCServlet: key=$request." + reqKey + "$ value=" + reqVal);
diff --git a/pki/base/common/src/com/netscape/cmscore/apps/CommandQueue.java b/pki/base/common/src/com/netscape/cmscore/apps/CommandQueue.java
index c4b14dc10c3c46ba15b0cdef3e536a49a110191b..6604fea5b92938f750cc84f98bdfe2b2b4347de9 100644
--- a/pki/base/common/src/com/netscape/cmscore/apps/CommandQueue.java
+++ b/pki/base/common/src/com/netscape/cmscore/apps/CommandQueue.java
@@ -17,6 +17,7 @@
 // --- END COPYRIGHT BLOCK ---
 package com.netscape.cmscore.apps;
 
+import java.util.Enumeration;
 import java.util.Hashtable;
 
 import javax.servlet.Servlet;
@@ -82,7 +83,7 @@ public class CommandQueue implements Runnable, ICommandQueue {
     }
 
     public void unRegisterProccess(Object currentRequest, Object currentServlet) {
-        java.util.Enumeration e = mCommandQueue.keys();
+        Enumeration<CMSRequest> e = mCommandQueue.keys();
 
         while (e.hasMoreElements()) {
             Object thisRequest = e.nextElement();
diff --git a/pki/base/common/src/com/netscape/cmscore/base/FileConfigStore.java b/pki/base/common/src/com/netscape/cmscore/base/FileConfigStore.java
index 8aac76e70711cacb90a00e67cb5dfc693454ac35..f0c52866e40f63853afcdc6bb9029f9586366858 100644
--- a/pki/base/common/src/com/netscape/cmscore/base/FileConfigStore.java
+++ b/pki/base/common/src/com/netscape/cmscore/base/FileConfigStore.java
@@ -172,8 +172,8 @@ public class FileConfigStore extends PropConfigStore implements
             String name) throws EBaseException,
             IOException {
         // print keys
-        Enumeration e0 = store.getPropertyNames();
-        Vector v = new Vector();
+        Enumeration<String> e0 = store.getPropertyNames();
+        Vector<String> v = new Vector<String>();
 
         while (e0.hasMoreElements()) {
             v.addElement(e0.nextElement());
@@ -197,7 +197,7 @@ public class FileConfigStore extends PropConfigStore implements
         }
 
         // print substores
-        Enumeration e1 = store.getSubStoreNames();
+        Enumeration<String> e1 = store.getSubStoreNames();
 
         while (e1.hasMoreElements()) {
             v.addElement(e1.nextElement());
diff --git a/pki/base/common/src/com/netscape/cmscore/base/PropConfigStore.java b/pki/base/common/src/com/netscape/cmscore/base/PropConfigStore.java
index d587a81f5ffd365acccf9e2602c3900a28321379..1f453a573babc06ff2cd4ebe0fc8a42ba8574bcf 100644
--- a/pki/base/common/src/com/netscape/cmscore/base/PropConfigStore.java
+++ b/pki/base/common/src/com/netscape/cmscore/base/PropConfigStore.java
@@ -170,8 +170,8 @@ public class PropConfigStore implements IConfigStore, Cloneable {
      * @see java.util.Hashtable#elements
      * @see java.util.Enumeration
      */
-    public Enumeration keys() {
-        Hashtable h = new Hashtable();
+    public Enumeration<String> keys() {
+        Hashtable<String, Object> h = new Hashtable<String, Object>();
 
         enumerate(h);
         return h.keys();
@@ -182,8 +182,8 @@ public class PropConfigStore implements IConfigStore, Cloneable {
      * 
      * @return hashtable
      */
-    public Hashtable hashtable() {
-        Hashtable h = new Hashtable();
+    public Hashtable<String, Object> hashtable() {
+        Hashtable<String, Object> h = new Hashtable<String, Object>();
 
         enumerate(h);
         return h;
@@ -193,7 +193,7 @@ public class PropConfigStore implements IConfigStore, Cloneable {
      * Return the number of items in this substore
      */
     public int size() {
-        Hashtable h = new Hashtable();
+        Hashtable<String, Object> h = new Hashtable<String, Object>();
 
         enumerate(h);
         return h.size();
@@ -206,8 +206,8 @@ public class PropConfigStore implements IConfigStore, Cloneable {
      * 
      * @param h the hashtable
      */
-    private synchronized void enumerate(Hashtable h) {
-        Enumeration e = mSource.keys();
+    private synchronized void enumerate(Hashtable<String, Object> h) {
+        Enumeration<String> e = mSource.keys();
         // We only want the keys which match the current substore name
         // without the current substore prefix.  This code works even
         // if mStoreName is null.
@@ -215,7 +215,7 @@ public class PropConfigStore implements IConfigStore, Cloneable {
         int kIndex = fullName.length();
 
         while (e.hasMoreElements()) {
-            String key = (String) e.nextElement();
+            String key = e.nextElement();
 
             if (key.startsWith(fullName)) {
                 h.put(key.substring(kIndex), nakedGet(key));
@@ -589,10 +589,11 @@ public class PropConfigStore implements IConfigStore, Cloneable {
      * 
      * @param name substore name
      */
+    @SuppressWarnings("unchecked")
     public void removeSubStore(String name) {
         // this operation is expensive!!!
 
-        Enumeration e = mSource.keys();
+        Enumeration<String> e = mSource.keys();
         // We only want the keys which match the current substore name
         // without the current substore prefix.  This code works even
         // if mStoreName is null.
@@ -600,10 +601,10 @@ public class PropConfigStore implements IConfigStore, Cloneable {
         int kIndex = fullName.length();
 
         while (e.hasMoreElements()) {
-            String key = (String) e.nextElement();
+            String key = e.nextElement();
 
             if (key.startsWith(fullName + ".")) {
-                ((Hashtable) mSource).remove(key);
+                ((Hashtable<String, String>) mSource).remove(key);
             }
         }
     }
@@ -649,16 +650,16 @@ public class PropConfigStore implements IConfigStore, Cloneable {
      * 
      * @return a list of string-based property names
      */
-    public Enumeration getPropertyNames() {
+    public Enumeration<String> getPropertyNames() {
         // XXX - this operation is expensive!!!
-        Hashtable h = new Hashtable();
+        Hashtable<String, Object> h = new Hashtable<String, Object>();
 
         enumerate(h);
-        Enumeration e = h.keys();
-        Vector v = new Vector();
+        Enumeration<String> e = h.keys();
+        Vector<String> v = new Vector<String>();
 
         while (e.hasMoreElements()) {
-            String pname = (String) e.nextElement();
+            String pname = e.nextElement();
             int i = pname.indexOf('.'); // substores have "."
 
             if (i == -1) {
@@ -678,16 +679,16 @@ public class PropConfigStore implements IConfigStore, Cloneable {
      * 
      * @return list of substore names
      */
-    public Enumeration getSubStoreNames() {
+    public Enumeration<String> getSubStoreNames() {
         // XXX - this operation is expensive!!!
-        Hashtable h = new Hashtable();
+        Hashtable<String, Object> h = new Hashtable<String, Object>();
 
         enumerate(h);
-        Enumeration e = h.keys();
-        Vector v = new Vector();
+        Enumeration<String> e = h.keys();
+        Vector<String> v = new Vector<String>();
 
         while (e.hasMoreElements()) {
-            String pname = (String) e.nextElement();
+            String pname = e.nextElement();
             int i = pname.indexOf('.'); // substores have "."
 
             if (i != -1) {
@@ -717,10 +718,10 @@ public class PropConfigStore implements IConfigStore, Cloneable {
      * substore.
      */
     public void printProperties() {
-        Enumeration keys = mSource.keys();
+        Enumeration<String> keys = mSource.keys();
 
         while (keys.hasMoreElements()) {
-            String key = (String) keys.nextElement();
+            String key = keys.nextElement();
 
             if (mStoreName == null) {
                 System.out.println(key);
@@ -762,10 +763,10 @@ public class PropConfigStore implements IConfigStore, Cloneable {
                         subs.nextElement();
                 IConfigStore newSub = that.makeSubStore(
                         sub.getName());
-                Enumeration props = sub.getPropertyNames();
+                Enumeration<String> props = sub.getPropertyNames();
 
                 while (props.hasMoreElements()) {
-                    String n = (String) props.nextElement();
+                    String n = props.nextElement();
 
                     try {
                         newSub.putString(n,
diff --git a/pki/base/common/src/com/netscape/cmscore/cert/CrossCertPairSubsystem.java b/pki/base/common/src/com/netscape/cmscore/cert/CrossCertPairSubsystem.java
index dbc0c607f518a7f4b8f90430d3a04be87d58d2d6..8d8a337c592a78398795d637b8b8fa797f54ba56 100644
--- a/pki/base/common/src/com/netscape/cmscore/cert/CrossCertPairSubsystem.java
+++ b/pki/base/common/src/com/netscape/cmscore/cert/CrossCertPairSubsystem.java
@@ -204,7 +204,8 @@ public class CrossCertPairSubsystem implements ICrossCertPairSubsystem {
                     return;
                 }
 
-                Enumeration en = caCerts.getByteValues();
+                @SuppressWarnings("unchecked")
+                Enumeration<byte[]> en = caCerts.getByteValues();
 
                 if ((en == null) || (en.hasMoreElements() == false)) {
                     debug("1st potential xcert");
@@ -216,7 +217,7 @@ public class CrossCertPairSubsystem implements ICrossCertPairSubsystem {
                 boolean match = false;
 
                 while (en.hasMoreElements()) {
-                    val = (byte[]) en.nextElement();
+                    val = en.nextElement();
                     debug("val =" + val.length);
                     if (val.length == 0) {
                         continue;
@@ -332,11 +333,12 @@ public class CrossCertPairSubsystem implements ICrossCertPairSubsystem {
         if (attr == null) {
             return false;
         }
-        Enumeration vals = attr.getByteValues();
+        @SuppressWarnings("unchecked")
+        Enumeration<byte[]> vals = attr.getByteValues();
         byte[] val = null;
 
         while (vals.hasMoreElements()) {
-            val = (byte[]) vals.nextElement();
+            val = vals.nextElement();
             if (val.length == 0)
                 continue;
             if (byteArraysAreEqual(val, bval)) {
@@ -418,7 +420,8 @@ public class CrossCertPairSubsystem implements ICrossCertPairSubsystem {
                     return;
                 }
 
-                Enumeration en = xcerts.getByteValues();
+                @SuppressWarnings("unchecked")
+                Enumeration<byte[]> en = xcerts.getByteValues();
 
                 if ((en == null) || (en.hasMoreElements() == false)) {
                     debug("publishCertPair found no pairs in internal db");
@@ -427,7 +430,7 @@ public class CrossCertPairSubsystem implements ICrossCertPairSubsystem {
                 byte[] val = null;
 
                 while (en.hasMoreElements()) {
-                    val = (byte[]) en.nextElement();
+                    val = en.nextElement();
                     debug("val =" + val.length);
                     if (val.length == 0) {
                         continue;
diff --git a/pki/base/common/src/com/netscape/cmscore/connector/HttpPKIMessage.java b/pki/base/common/src/com/netscape/cmscore/connector/HttpPKIMessage.java
index af72fee45d0c2a4f212f47a707ef72188fcc81e8..d7024f4ad58520a74846bd7a327e040f205509a8 100644
--- a/pki/base/common/src/com/netscape/cmscore/connector/HttpPKIMessage.java
+++ b/pki/base/common/src/com/netscape/cmscore/connector/HttpPKIMessage.java
@@ -43,7 +43,7 @@ public class HttpPKIMessage implements IHttpPKIMessage {
     public String reqType = "";
     public String reqId = "";
     protected String reqStatus = "";
-    protected Vector mNameVals = new Vector(); // sequence of name/vals.
+    protected Vector<Object> mNameVals = new Vector<Object>(); // sequence of name/vals.
 
     public HttpPKIMessage() {
     }
@@ -94,6 +94,7 @@ public class HttpPKIMessage implements IHttpPKIMessage {
     /**
      * copy contents to request.
      */
+    @SuppressWarnings("unchecked")
     public void toRequest(IRequest r) {
         // id, type and status 
         // type had to have been set in instantiation.
@@ -105,7 +106,7 @@ public class HttpPKIMessage implements IHttpPKIMessage {
         int len = RequestTransfer.getTransferAttributes(r).length;
         String key;
         Object value;
-        Enumeration enum1 = mNameVals.elements();
+        Enumeration<Object> enum1 = mNameVals.elements();
 
         while (enum1.hasMoreElements()) {
             key = (String) enum1.nextElement();
@@ -137,7 +138,7 @@ public class HttpPKIMessage implements IHttpPKIMessage {
         out.writeObject(reqStatus);
         if (Debug.ON)
             Debug.trace("read object req source status " + reqStatus);
-        Enumeration enum1 = mNameVals.elements();
+        Enumeration<Object> enum1 = mNameVals.elements();
 
         while (enum1.hasMoreElements()) {
             Object key = null;
@@ -175,7 +176,7 @@ public class HttpPKIMessage implements IHttpPKIMessage {
         reqType = (String) in.readObject();
         reqId = (String) in.readObject();
         reqStatus = (String) in.readObject();
-        mNameVals = new Vector();
+        mNameVals = new Vector<Object>();
         Object keyorval = null;
 
         try {
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/ByteArrayMapper.java b/pki/base/common/src/com/netscape/cmscore/dbs/ByteArrayMapper.java
index a51905c79e5e7398a9c774713d84b054f5514a67..38362f3412f67525ef5cf5d4141761ea758f1349 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/ByteArrayMapper.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/ByteArrayMapper.java
@@ -39,7 +39,7 @@ import com.netscape.certsrv.dbs.IDBObj;
 public class ByteArrayMapper implements IDBAttrMapper {
 
     private String mLdapName = null;
-    private Vector v = new Vector();
+    private Vector<String> v = new Vector<String>();
 
     /**
      * Constructs a byte array mapper.
@@ -52,7 +52,7 @@ public class ByteArrayMapper implements IDBAttrMapper {
     /**
      * Lists a list of supported ldap attribute names.
      */
-    public Enumeration getSupportedLDAPAttributeNames() {
+    public Enumeration<String> getSupportedLDAPAttributeNames() {
         return v.elements();
     }
 
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/CRLIssuingPointRecord.java b/pki/base/common/src/com/netscape/cmscore/dbs/CRLIssuingPointRecord.java
index df44797f12f948a65c47c7f8d6588b5659579a3a..9f0797d40d97856cb67bd7758e5a7a3ec7cc2311 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/CRLIssuingPointRecord.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/CRLIssuingPointRecord.java
@@ -56,7 +56,7 @@ public class CRLIssuingPointRecord implements ICRLIssuingPointRecord, IDBObj {
     protected Hashtable mUnrevokedCerts = null;
     protected Hashtable mExpiredCerts = null;
     protected byte mDeltaCRL[] = null;
-    protected static Vector mNames = new Vector();
+    protected static Vector<String> mNames = new Vector<String>();
     static {
         mNames.addElement(ATTR_ID);
         mNames.addElement(ATTR_CRL_NUMBER);
@@ -197,11 +197,11 @@ public class CRLIssuingPointRecord implements ICRLIssuingPointRecord, IDBObj {
         throw new EBaseException(CMS.getUserMessage("CMS_BASE_INVALID_ATTRIBUTE", name));
     }
 
-    public Enumeration getElements() {
+    public Enumeration<String> getElements() {
         return mNames.elements();
     }
 
-    public Enumeration getSerializableAttrNames() {
+    public Enumeration<String> getSerializableAttrNames() {
         return mNames.elements();
     }
 
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/CertRecordMapper.java b/pki/base/common/src/com/netscape/cmscore/dbs/CertRecordMapper.java
index 3f5895ade905109ea3e83d144563a8d99626471a..f4074c2132d132e771e3be9ebb2841f9af7a92c5 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/CertRecordMapper.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/CertRecordMapper.java
@@ -49,8 +49,8 @@ public class CertRecordMapper implements IDBAttrMapper {
         mDB = db;
     }
 
-    public Enumeration getSupportedLDAPAttributeNames() {
-        Vector v = new Vector();
+    public Enumeration<String> getSupportedLDAPAttributeNames() {
+        Vector<String> v = new Vector<String>();
 
         v.addElement(CertDBSchema.LDAP_ATTR_CERT_RECORD_ID);
         return v.elements();
